#!/usr/bin/env python
# coding=utf-8

import cbor
import time
import logging
import random
import json


from sls import ebike

from aliyunsdkdysmsapi.request.v20170525 import SendSmsRequest
from aliyunsdkdysmsapi.request.v20170525 import QuerySendDetailsRequest
from aliyunsdkcore.client import AcsClient
import uuid
import oss2

MAX_WEIGHT = 120
SIGN_NAME = "云栖WorkShop"
TEMPLATE_CODE = "SMS_97400006"

LOGGER = logging.getLogger()

def get_attrbute_value(record, column):
    attrs = record[u'Columns']
    for x in attrs:
        if x[u'ColumnName'] == column:
            return x['Value']

def get_pk_value(record, column):
    attrs = record[u'PrimaryKey']
    for x in attrs:
        if x['ColumnName'] == column:
            return x['Value']

def send_sms(business_id, phone_number, sign_name, template_code, template_param=None):
    TMP_REGION = "cn-hangzhou"
    #下述AK为临时使用短信的子账号，只有短信服务访问权限，并将于workshop后删除
    TMP_ACCESS_KEY_ID = "LTAI9LJKKo6TpoVX"
    TMP_ACCESS_KEY_SECRET = "IbzQp2huDwxbHawtcfz3Dxv5hWm5jR"
    acs_client = AcsClient(TMP_ACCESS_KEY_ID, TMP_ACCESS_KEY_SECRET, TMP_REGION)
    smsRequest = SendSmsRequest.SendSmsRequest()
    smsRequest.set_TemplateCode(template_code)
    if template_param is not None:
        smsRequest.set_TemplateParam(template_param)
    smsRequest.set_OutId(business_id)
    smsRequest.set_SignName(sign_name)
    smsRequest.set_PhoneNumbers(phone_number)
    smsResponse = acs_client.do_action_with_exception(smsRequest)
    return smsResponse

def my_handler(event, context):
    random.seed()
    records = cbor.loads(event)
    #records = json.loads(event)
    LOGGER.info('Records %s', records)

    for record in records['Records']:
        MobileNo = get_attrbute_value(record, 'MobileNo')
        Weight = get_attrbute_value(record, 'Weight')
        Bid = get_attrbute_value(record, 'Bid')
        Uid = get_pk_value(record, 'Uid')
        Sid = get_pk_value(record, 'Sid')
        CreateTime = get_pk_value(record, 'CreateTime')
        ebike.report_status(MobileNo, Weight, Bid, Uid, Sid)
        if Weight is None:
            LOGGER.error('Not found column: %s in %s', 'Weight', record)
        else:
            if Weight < MAX_WEIGHT:
                if int(time.time()%300) == 0:
                    LOGGER.info('Status is Normal, Uid: %d, SessionId: %d , TimeStamp: %d', Uid, Sid, CreateTime)
                continue
            else:
                params = {"user":Uid, "vid":Bid, "expect":MAX_WEIGHT, "actual":Weight}
                business_id = uuid.uuid1()
                res = send_sms(business_id, MobileNo, SIGN_NAME, TEMPLATE_CODE, str(params))
                res_dict = eval(res)
                if not res_dict.has_key("Message") or res_dict["Message"] != 'OK':
                    LOGGER.error('Message %s send fail: %s', 'Weight', params, res)
    return 'OK'


